package intro2java;
import robocode.*;

/**
 * DoCorner -- travels in a square forever. Uses 
 * an instance variable to decide whether to turn 
 * clockwise or anti-clockwise, and spins the gun 
 * at each turn.
 */
public class DoCorner extends Robot
{
    public final static int LENGTH_OF_SQUARE = 150;
	
	private int numberOfSquares;
	private boolean clockwise;
	
	public DoCorner()
	{
		numberOfSquares = 0;
		clockwise = false;
	}
	
	public void run() {
		while(true) {
			moveInSquare(LENGTH_OF_SQUARE);
			out.println("Moved " + numberOfSquares + " squares");
		}
	}

	private void moveInSquare(int lengthOfSize)
	{
		for (int i=0; i < 4; i++)
		{
			ahead(LENGTH_OF_SQUARE);
			doCorner();
		}						
		numberOfSquares++;			
	}	
	
	private void doCorner()
	{
		if (clockwise)
		{
			turnRight(90);
		}
		else
		{
			turnLeft(90);
		}
		turnGunRight(360);
	}
}
	