package intro2java;
import robocode.*;

/**
 * DoCorner -- travels in a square forever. Uses 
 * a number of instance variables to control its 
 * behaviour
 */
public class DoCornerAdvanced extends Robot
{
    public final static int LENGTH_OF_SQUARE = 150;
	public final static int GUN_ROTATION = 360;
	public final static int RADAR_ROTATION = 360;
	
	private int numberOfSquares;
	private boolean clockwise;
	private boolean aggresive;
	private boolean scanForRobots;
	private int sizeOfSquare;
	private int gunRotation;
	private int radarRotation;
	
	public DoCornerAdvanced()
	{
		numberOfSquares = 0;
		clockwise = false;
		aggresive = true;
		scanForRobots = true;
		sizeOfSquare = LENGTH_OF_SQUARE;
		gunRotation = GUN_ROTATION;
		radarRotation = RADAR_ROTATION;
	}
	
	public void run() {
		while(true) {
			moveInSquare(LENGTH_OF_SQUARE);
			out.println("Moved " + numberOfSquares + " squares");
		}
	}

	private void moveInSquare(int lengthOfSize)
	{
		for (int i=0; i < 4; i++)
		{
			ahead(LENGTH_OF_SQUARE);
			doCorner();
		}						
		numberOfSquares++;			
	}	
	
	private void doCorner()
	{
		if (clockwise)
		{
			turnRight(90);
		}
		else
		{
			turnLeft(90);
		}
		turnGunRight(gunRotation);
		if (scanForRobots)
		{
			turnRadarRight(radarRotation);
		}
		if (aggresive)
		{
			fire(1);
		}
	}
}
		